#!/usr/bin/perl
use Date::Manip;

&Date_Init("Language=English","DateFormat=non-US");

$start_date = "20/6/2003";
$uinfo_file = "./uinfo.txt";
$events_file = "./events.txt";

open (UINFO, $uinfo_file);

# add players from a uinfo file
my %pids;
while (<UINFO>) {
   @current = split(/\t/, $_);
   if($current[2] eq "") {next;}
   system "./add_player.exp '$current[2]' '$current[6]' '$current[3]' '$current[5]' '$current[4]' '$current[16]' '$current[15]'\n";
   $id = $current[0];
   $id =~ s/\*//;
   $pids{$id} = $current[2];
   print "Added $current[2]\n";
}

# move all player instantiation to the game start time - in milisec
$start_epoch=Date_SecsSince1970GMT($start_date);
$start_epock *= 1000;
$sql = "UPDATE maytest_events SET time=$start_epoch";
system "mysql -u assassins -D assassins --password=PASSWORD -e '$sql'";

open (EVENTS, $events_file);

# add events from an events file
while(<EVENTS>) {
   @current = split(/\t/, $_);
   $flags = hex($current[2]);
   $succesful = $flags%2;
   
   $victim = $current[6];
   $killer = $current[3];
   
# is it a kill or something else?
   if(!($flags & (1<<7))) { next; }
# has it been anulled?
   if($flags & (1<<25)) { next; }
   if($victim eq "npleg") { next; }
   if($victim eq "npill") { next; }
   
   $time = $current[1];
   $game_day = substr($time, 0, 3);
   $au_date = DateCalc($start_date, "+ $game_day days", \$err);
   $au_date = UnixDate($au_date, "%d-%m-%Y");
   $hour = substr($time, 3, 2);
   $minute = substr($time, 5, 2);
   $au_time = "$au_date $hour:$minute:00";
   
   system "./add_event.exp \"$pids{$killer}\" \"$pids{$victim}\" \"$succesful\" \"$au_time\"";
   print "Added $pids{$killer} --> $pids{$victim} at $au_time\n";
}
