/**
 * Class which wraps ResultSet in order to provide a close method
 * which also closes the statement.
 * we replace the close method only and make it close the statement
 * as well, this is only neccessary due to needing the statement still
 * open for Connector/J resultsets to be valid as opposed to 
 * org.gjt.mm.mysql ones.
 * Most just genreated via perl script from java.sql.ResultSet
 */

package org.ucam.srcf.assassins;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

public class AResultSet {
	public ResultSet encapsulated=null;
	private Statement stat=null;

	AResultSet(ResultSet r, Statement s) throws AssassinSQLException {
		this.encapsulated=(ResultSet) r;
		this.stat=s;
	}
	
	public void close() throws SQLException {
		/* It is also noted that Connector/J differs from 
		 * org.gjt.mm.mysql in that if a result returns no
		 * result sets then we can't retreive them under 
		 * Connector/J. We handle this by testing for nullness
		 * here instead to maintain backwards compat.
		 */
		/* Closes the statment which generated this, which in turn
		 * cloese the encapsualted ResultSet */
		if(stat!=null)
			stat.close();
		stat=null;
	}
}

