/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

/**
 * Viewer for the assassin class. 
 */
public class AssassinViewer extends CanonicalViewer
{
   AssassinViewer(Assassin a)
   {
      this.ent = a;
   }

   public int getAid()
   {
      return ((Assassin) ent).getAid();
   }
   
   /**
    * Determine which player this assassin is played by.
    * @return A viewer for the player who plays this assassin.
    */
   public PlayerViewer getPlayerViewer() throws AssassinSQLException
   {
      if (Debug.debug) Debug.print(AssassinViewer.class, "in getPlayerViewer");
      PlayerViewer pv = new PlayerViewer(((Assassin)this.ent).getPlayer());
      if (Debug.debug) Debug.print(AssassinViewer.class, "returning");
      return pv;
   }

   public String getPrintable() throws AssassinSQLException
   {
      return ((Assassin) ent).getPrintable();
   }

   public int countKillsAtTime(long t) throws AssassinSQLException {
      return ((Assassin) ent).countKillsAtTime(t);
   }
   public int countDeathsAtTime(long t) throws AssassinSQLException {
      return ((Assassin) ent).countDeathsAtTime(t);
   }

   public boolean isAliveAtTime(long t) throws AssassinSQLException {
      return ((Assassin) ent).isAliveAtTime(t);
   }

   public double sumPluginFieldAtTime(String p, String f, long t) throws AssassinSQLException {
      return ((Assassin) ent).sumPluginFieldAtTime(p,f,t);
   }
}

