/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIInvalidContentFormatException;

public class CGIQuickLinks implements CGICommand
{
   void showLinks(CGI cgi, Map plugins, Map params) throws AssassinSQLException, CGIInvalidContentFormatException
   {
      cgi.out("<h2>Welcome to the AutoUmpire</h2>");
      cgi.out("<p>");
      cgi.out("  Select one of the following functions, or a command from the menu:");
      cgi.out("</p>");
      cgi.out("<ul>");
      List as = umpirecgi.currentAuth.getPlayerViewer().getAssassins();
      if (as.size() > 0)
         cgi.out("   <li><a href='umpire.cgi?edit-assassin,"+((Assassin)((AssassinViewer)as.get(0)).getEntity()).getAid()+"'>Show my details</a></li>");
      cgi.out("   <li><a href='umpire.cgi?report-kill'>I just killed someone&mdash;give me points!</a></li>");
      cgi.out("   <li><a href='umpire.cgi?report-death'>Someone just killed me&mdash;the bastard!</a></li>");
      cgi.out("   <li><a href='umpire.cgi?add-event'>I want to add an event</a></li>");
      cgi.out("   <li><a href='umpire.cgi?add-pseudonym'>I want to give myself a new pseudonym.</a></li>");
      cgi.out("   <li><a href='umpire.cgi?add-report'>I want to add a report to an event.</a></li>");
      cgi.out("</ul>");
      cgi.out("<h3>Reporting Problems</h3>");
      cgi.out("<p>");
      cgi.out("   We welcome feedback and bug reports about the AutoUmpire.");
      cgi.out("   If you experience any problems using the system, please email");
      cgi.out("   <a href='mailto:assassins-autoumpire-devel@srcf.ucam.org'>assassins-autoumpire-devel@srcf.ucam.org</a>.");
      cgi.out("</p>");
   }

   public void command(CGI cgi, Map plugins, Map params, long nowtime) 
      throws AssassinSQLException, IOException, ParseException, CGIInvalidContentFormatException { showLinks(cgi, plugins, params); } 
   public String getName() { return "Quick Links"; }
   public String getDescription() { return "A list of useful funtions"; }
   public AuthLevel accessLevel () { return AuthLevel.PLAYER; }
   public String getSection() { return "Misc"; }
   public boolean isVisible() {	return false; }
}

