/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.NotSerialisedEntityException;

/**
 * A class for showing a dropdown of entities, and recovering the entity afterwards
 */
public class MultipleCanonicalEntityField extends CanonicalEntityField
{
   public MultipleCanonicalEntityField(String name, String label, List entities, CanonicalEntity defentity)
   {
      super(name, label, entities, defentity);
   }

   public MultipleCanonicalEntityField(String name, String label, List entities, CanonicalViewer defentity)
   {
      super(name, label, entities, defentity);
   }
   
   public MultipleCanonicalEntityField(String name, String label, CanonicalEntity[] entities, CanonicalEntity defentity)
   {
      super(name, label, entities, defentity);
   }

   public MultipleCanonicalEntityField(String name, String label, CanonicalEntity[] entities, CanonicalViewer defentity)
   {
      super(name, label, entities, defentity);
   }
    
   public MultipleCanonicalEntityField(String name, String label, CanonicalViewer[] entities, CanonicalEntity defentity)
   {
      super(name, label, entities, defentity);
   }

   public MultipleCanonicalEntityField(String name, String label, CanonicalViewer[] entities, CanonicalViewer defentity)
   {
      super(name, label, entities, defentity);
   }
   
   protected String print()
   {
      String s = "";
      s += "<select name='"+name+"' multiple='multiple' size='6'>\n";
      for (int i=0; i<entities.length; i++)
         try {
            if (entities[i].equals(defentity))
               s += "   <option value='"+entities[i].toString()+"' selected='selected'>"+Tools.escapeXML(entities[i].getPrintable())+"</option>\n";
            else
               s += "   <option value='"+entities[i].toString()+"'>"+Tools.escapeXML(entities[i].getPrintable())+"</option>\n";
         } catch (AssassinSQLException ASQLe) {}
      s += "</select>\n";
      return s;
   }

   static List getResultEntityList(List POSTvalue) throws NotSerialisedEntityException
   {
      LinkedList l = new LinkedList();
      Iterator i = POSTvalue.iterator();
      while (i.hasNext())
         l.add(CanonicalEntity.deSerialise((String) i.next()));
      return l;
   }
 
   public static List getResultViewerList(List POSTvalue) throws NotSerialisedEntityException
   {
      LinkedList l = new LinkedList();
      Iterator i = POSTvalue.iterator();
      while (i.hasNext())
         l.add(CanonicalEntity.deSerialise((String) i.next()).getViewer());
      return l;
   }
   
}


