/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.Map;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;

/**
 * Interface for commands to add to the interface
 */
public abstract class PluginCommand implements Command
{
   public final void command(Map plugins, Map params, long nowtime) throws AssassinSQLException, IOException, ParseException, StateBuilderException
   {
      /*StateBuilder sb = new StateBuilder(plugins);
      Map state;
      try {
	      state = sb.buildStateAtTime(nowtime);
      } catch (StateBuilderException sbe) {
	      throw new RuntimeException();
      }
      state = autoumpire.viewerifyStateMap(state);*/
      pluginCommand(params);
   }
   
	/**
	 * Called whenever the command that this class represents is run.
	 * @param state The current gamestate, a map from AssassinViewers =&gt; 
	 *						AssassinStateViewers
	 * @param params A Map from String=&gt;String which is "-option"=&gt;
	 *						"optionvalue" or null depending if on optonvalue was
	 *						specified or not.
	 */
   public abstract void pluginCommand(Map params) throws AssassinSQLException, IOException, ParseException, StateBuilderException;

}
