/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

/**
 * Class representing resurrection state changes.
 *
 * @author Matthew Johnson <autoumpire@matthew.ath.cx>
 */
public class Resurrection extends StateChange
{
   public Resurrection(Assassin a)
   {
      super();
      this.ass = a;
      this.pluginName = "vanilla";
      this.field = "resurrected";
      this.value = "";
   }
   public Resurrection(AssassinViewer a)
   {
      super();
      this.ass = (Assassin) a.getEntity();
      this.pluginName = "vanilla";
      this.field = "resurrected";
      this.value = "";
   }
   Resurrection(int scid)
   {
      super(scid);
   }
   Resurrection(Integer scid)
   {
      super(scid);
   }
   public String toString() { return "__::"+StateChange.class.getName()+"("+id+")"; }
}
