package org.ucam.srcf.assassins.xml;

import java.io.OutputStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Stack;

import org.ucam.srcf.assassins.Assassin;
import org.ucam.srcf.assassins.AssassinState;
import org.ucam.srcf.assassins.NewsPage;
import org.xml.sax.Attributes;

public class DynamicPageHandler extends Handler {
	
	private Assassin assassin;
	
	public void setAssassin(Assassin a) {
		this.assassin=a;
	}

	public DynamicPageHandler(OutputStream o,String t,Map s,Map p,Set s2) {
		super(o,t,s,p,s2);
	}

	/**
	 * @see org.ucam.srcf.assassins.xml.Handler#startDocument()
	 */
	public void startDocument() {
		out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
		out.println("<webpage>");
	}

	/**
	 * @see org.ucam.srcf.assassins.xml.Handler#endDocument()
	 */
	public void endDocument() {
		out.println("  <links>");
		if (linkedPages!=null) {
			for (Iterator i = linkedPages.iterator(); i.hasNext();) {
			NewsPage np = (NewsPage) i.next();
			String l = np.getLinkName();
			String t = np.getTitle();
			if (l!=target) out.println(" <a href=\""+l+"\">"+t+"</a>");
		}
		}
		out.println("    <a href=\""
				+ Config.getConfig("vanilla", "updates-page-name")
				+ ".html\">Updates</a>");
		out.println("    <a href=\""
				+ Config.getConfig("vanilla", "headlines-page-name")
				+ ".html\">Headlines</a>");
		int index = 1;
		String s = null;
		while (null != (s = Config.getConfig("vanilla", "template-page-name-"
				+ index))) {
			out.println("    <a href=\"" + s + ".html\">" + s + "</a>");
			index++;
		}
		out.println("  </links>");
		out.println("</webpage>");
		out.close();
	}

	/**
	 * @see org.ucam.srcf.assassins.xml.Handler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void startElement(String namespaceURI, String name, String qName, Attributes atts) {
		if (name.equalsIgnoreCase("title")) {
			out.print("<title>");
			currentState = Handler.TEXT;
			return;
		}
		if (name.equalsIgnoreCase("text")) {
			out.print("<text>");
			currentState = Handler.TEXT;
			return;
		}
		if (name.equalsIgnoreCase("empty")) {
			if (currentList.size() == 0) {
				out.print("<text>");
			}
			currentState = PageHandler.EMPTY;
			return;
		}
		if (name.equalsIgnoreCase("list")) {
			currentList = new LinkedList(state.keySet());
			toRemove = new HashSet();
			columns = new HashMap();
			columnList = new LinkedList();
			sorter=null;
			pendingFilters=new Stack();
			return;
		}
		if (name.equalsIgnoreCase("sort")) {
			sorter = new AssComp(atts.getValue("plugin"),
					atts.getValue("name"),
					state,
					new Boolean(atts.getValue("descending")).booleanValue(),
					atts.getValue("numeric"));
			return;
		}
		if (name.equalsIgnoreCase("column")) {
			List temp = new LinkedList();
			temp.add(atts.getValue("name"));
			temp.add(atts.getValue("plugin"));
			columns.put(atts.getValue("title"), temp);
			columnList.add(atts.getValue("title"));
			return;
		}
		if (name.equalsIgnoreCase("plugin")) {
			String pName = atts.getValue("name");
			if (name==null) name="vanilla";
			String pParam = atts.getValue("parameter");
			if (pParam == null) return; // Something went wrong
			String s = Config.getConfig(pName, pParam);
			out.print(s);
			return;
		}
		if (name.equalsIgnoreCase("property")) {
			String className = atts.getValue("class");
			String plugin = atts.getValue("plugin");
			String value = atts.getValue("value");
//			String arguments = atts.getValue("arguments");
//			StringTokenizer st = new StringTokenizer(arguments,",");
//			Class [] args = new Class[st.countTokens()];
//			int i=0;
//			while (st.hasMoreTokens()) {
//				String s = st.nextToken();
//				try {
//					Class x = Class.forName(s);
//					args[i++]=x;
//				} catch (ClassNotFoundException e) {
//					out.print("Illegal argument "+s);
//					return;
//				}
//			}
			try {
				Class myClass = Class.forName(className);
//				Method m = myClass.getMethod("getById", new Class[] {Integer.class});
//				m.invoke(myClass,new Object[] {new Integer(0)});
//				Method m2 = myClass.getMethod(index, args);
				if (myClass.isAssignableFrom(Assassin.class)) {
					AssassinState as = (AssassinState) state.get(assassin);
					if (as==null) {
						out.print("null");
					} else {
						out.print(as.getProperty(plugin, value));
					}
				}
			} catch (ClassNotFoundException e) {
				out.print("Could not find class "+className);
			}
			return;
		}
		if (name.equalsIgnoreCase("webpage")) return;
		out.print("<"+name+">");
	}

	/**
	 * @see org.ucam.srcf.assassins.xml.Handler#endElement(java.lang.String, java.lang.String, java.lang.String)
	 */
	public void endElement(String namespaceURI, String name, String qName) {
			if (name.equalsIgnoreCase("title")) {
			out.println("</title>");
			currentState=Handler.NOTHING;
			return;
		}
		if (name.equalsIgnoreCase("property")) return;
		if (name.equalsIgnoreCase("webpage")) return;
		out.println("</"+name+">");
	}


}
